# The Rust Programming Language

_by Steve Klabnik, Carol Nichols, and Chris Krycho, with contributions from the
Rust Community_

This version of the text assumes you’re using Rust 1.85.0 (released 2025-02-17)
or later with `edition = "2024"` in the Cargo.toml file of all projects to
configure them to use Rust 2024 edition idioms. See the [“Installation” section
of Chapter 1][install]<!-- ignore --> to install or update Rust.

The HTML format is available online at
[https://doc.rust-lang.org/stable/book/](https://doc.rust-lang.org/stable/book/)
and offline with installations of Rust made with `rustup`; run `rustup doc
--book` to open.

Several community [translations] are also available.

This text is available in [paperback and ebook format from No Starch
Press][nsprust].

[install]: ch01-01-installation.html
[nsprust]: https://nostarch.com/rust-programming-language-2nd-edition
[translations]: appendix-06-translation.html

> **🚨 Want a more interactive learning experience? Try out a different version
> of the Rust Book, featuring: quizzes, highlighting, visualizations, and
> more**: <https://rust-book.cs.brown.edu>
