# 2025-01-20 Triage Log

A very quiet week for performance, with small improvements essentially on all
benchmarks.

Triage done by **@simulacrum**.
Revision range: [1ab85fbd..9a1d156f](https://perf.rust-lang.org/?start=1ab85fbd7474e8ce84d5283548f21472860de3e2&end=9a1d156f38c51441ee51e5a068f1d0caf4bb0f27&absolute=false&stat=instructions%3Au)

**Summary**:

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.7%  | [0.3%, 1.0%]   | 3     |
| Regressions ❌ <br /> (secondary)  | 0.7%  | [0.5%, 1.0%]   | 4     |
| Improvements ✅ <br /> (primary)   | -0.4% | [-1.3%, -0.1%] | 155   |
| Improvements ✅ <br /> (secondary) | -0.5% | [-1.8%, -0.1%] | 94    |
| All ❌✅ (primary)                 | -0.4% | [-1.3%, 1.0%]  | 158   |


0 Regression, 1 Improvement, 2 Mixed; 0 of them in rollups
40 artifact comparisons made in total

#### Regressions

No statistically significant regressions this cycle.

#### Improvements

Stable Hash: Ignore all HirIds that just identify the node itself [#135329](https://github.com/rust-lang/rust/pull/135329) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=bcd0683e5dce1945b5d940714742e7502883bb5c&end=6067b36314ab5eb2eb47cecc464545ba58e1ad24&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | -     | -              | 0     |
| Regressions ❌ <br /> (secondary)  | -     | -              | 0     |
| Improvements ✅ <br /> (primary)   | -0.4% | [-0.9%, -0.1%] | 169   |
| Improvements ✅ <br /> (secondary) | -0.5% | [-1.3%, -0.1%] | 85    |
| All ❌✅ (primary)                 | -0.4% | [-0.9%, -0.1%] | 169   |


#### Mixed

Less unsafe in `dangling`/`without_provenance` [#135344](https://github.com/rust-lang/rust/pull/135344) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=d61f55d8b9d4703207a5980f27b6c28973ba27ee&end=d8a64098c9d0fb25699f657c6efff0bb418f7e18&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 1.2%  | [0.4%, 2.1%]   | 2     |
| Regressions ❌ <br /> (secondary)  | -     | -              | 0     |
| Improvements ✅ <br /> (primary)   | -0.5% | [-0.9%, -0.3%] | 3     |
| Improvements ✅ <br /> (secondary) | -1.1% | [-1.6%, -0.6%] | 4     |
| All ❌✅ (primary)                 | 0.2%  | [-0.9%, 2.1%]  | 5     |

Regressions look likely to be noise/modality in benchmarks, not genuine changes
caused by this work. See also some
[analysis](https://github.com/rust-lang/rust/pull/135344#issuecomment-2591403244)
on the PR.

Temporarily bring back `Rvalue::Len` [#135709](https://github.com/rust-lang/rust/pull/135709) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=98572840b6da350e5615a68586a766a0f9f1470a&end=c62b732724b6beb50a5c73be26d0c5f668504059&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.3%  | [0.3%, 0.3%]   | 1     |
| Regressions ❌ <br /> (secondary)  | 0.4%  | [0.2%, 0.5%]   | 6     |
| Improvements ✅ <br /> (primary)   | -0.7% | [-1.3%, -0.4%] | 3     |
| Improvements ✅ <br /> (secondary) | -0.9% | [-1.7%, -0.2%] | 2     |
| All ❌✅ (primary)                 | -0.4% | [-1.3%, 0.3%]  | 4     |

Fixing P-critical regression, so easily justified.
