# 2025-03-03 Triage Log

A pretty quiet week, with minimal changes in performance (positive or negative).

Triage done by **@simulacrum**.
Revision range: [f5729cfe..daf59857](https://perf.rust-lang.org/?start=f5729cfed3c45e061e8a443677fc1d5ef9277df7&end=daf59857d6d2b87af4b846316bf1561a6083ed51&absolute=false&stat=instructions%3Au)

**Summary**:

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.4%  | [0.2%, 0.6%]   | 16    |
| Regressions ❌ <br /> (secondary)  | 0.3%  | [0.1%, 0.6%]   | 27    |
| Improvements ✅ <br /> (primary)   | -0.4% | [-1.1%, -0.2%] | 27    |
| Improvements ✅ <br /> (secondary) | -1.0% | [-4.1%, -0.1%] | 63    |
| All ❌✅ (primary)                 | -0.1% | [-1.1%, 0.6%]  | 43    |


1 Regressions, 4 Improvements, 1 Mixed; 2 of them in rollups
29 artifact comparisons made in total

#### Regressions

Remove `NtPat`, `NtMeta`, and `NtPath` [#137517](https://github.com/rust-lang/rust/pull/137517) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=287487624357c19b22d27aa3ed584b8ccd080b4d&end=aa3c2d73eff57d6b019c26a1e9aa8afd8bc186ad&stat=instructions:u)

| (instructions:u)                   | mean | range        | count |
|:----------------------------------:|:----:|:------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.3% | [0.2%, 0.4%] | 16    |
| Regressions ❌ <br /> (secondary)  | 0.4% | [0.3%, 0.6%] | 9     |
| Improvements ✅ <br /> (primary)   | -    | -            | 0     |
| Improvements ✅ <br /> (secondary) | -    | -            | 0     |
| All ❌✅ (primary)                 | 0.3% | [0.2%, 0.4%] | 16    |

> The perf regressions are expected and unavoidable, alas.

https://github.com/rust-lang/rust/pull/137517#issuecomment-2692915586

#### Improvements

Change interners to start preallocated with an increased capacity [#137354](https://github.com/rust-lang/rust/pull/137354) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=2af87eab3b4890d62ad998cf9c55e076d91bf06a&end=ac91805f3179fc2225c60e8ccf5a1daa09d43f3d&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.3%  | [0.3%, 0.4%]   | 2     |
| Regressions ❌ <br /> (secondary)  | 0.2%  | [0.2%, 0.2%]   | 2     |
| Improvements ✅ <br /> (primary)   | -0.3% | [-0.6%, -0.2%] | 39    |
| Improvements ✅ <br /> (secondary) | -0.4% | [-1.1%, -0.1%] | 63    |
| All ❌✅ (primary)                 | -0.3% | [-0.6%, 0.4%]  | 41    |


Rollup of 8 pull requests [#137710](https://github.com/rust-lang/rust/pull/137710) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=e6059f522264ed2ec3ede21bfeef15bf3d814bf7&end=cb08599451226d780b2490f1aa9b414fe9e36657&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | -     | -              | 0     |
| Regressions ❌ <br /> (secondary)  | -     | -              | 0     |
| Improvements ✅ <br /> (primary)   | -     | -              | 0     |
| Improvements ✅ <br /> (secondary) | -2.0% | [-2.8%, -1.3%] | 9     |
| All ❌✅ (primary)                 | -     | -              | 0     |


`librustdoc`: return `impl fmt::Display` in more places instead of writing to strings [#137425](https://github.com/rust-lang/rust/pull/137425) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=4b696e6bf77b4df02634d346637bd35f2960c5f4&end=7c4a55c2ac6497629c273ccd00e185583542f0d2&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | -     | -              | 0     |
| Regressions ❌ <br /> (secondary)  | -     | -              | 0     |
| Improvements ✅ <br /> (primary)   | -0.6% | [-1.2%, -0.2%] | 4     |
| Improvements ✅ <br /> (secondary) | -     | -              | 0     |
| All ❌✅ (primary)                 | -0.6% | [-1.2%, -0.2%] | 4     |


Optimize empty provenance range checks. [#137704](https://github.com/rust-lang/rust/pull/137704) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=f4a216d28ee635afce685b4206e713579f66e130&end=daf59857d6d2b87af4b846316bf1561a6083ed51&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | -     | -              | 0     |
| Regressions ❌ <br /> (secondary)  | -     | -              | 0     |
| Improvements ✅ <br /> (primary)   | -0.3% | [-0.3%, -0.3%] | 3     |
| Improvements ✅ <br /> (secondary) | -1.9% | [-3.4%, -0.2%] | 13    |
| All ❌✅ (primary)                 | -0.3% | [-0.3%, -0.3%] | 3     |


#### Mixed

Rollup of 10 pull requests [#137796](https://github.com/rust-lang/rust/pull/137796) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=aa3c2d73eff57d6b019c26a1e9aa8afd8bc186ad&end=30508faeb3248d399079513b6e0107af30a43948&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.3%  | [0.1%, 0.4%]   | 9     |
| Regressions ❌ <br /> (secondary)  | 0.3%  | [0.2%, 0.5%]   | 8     |
| Improvements ✅ <br /> (primary)   | -0.6% | [-0.9%, -0.2%] | 2     |
| Improvements ✅ <br /> (secondary) | -     | -              | 0     |
| All ❌✅ (primary)                 | 0.1%  | [-0.9%, 0.4%]  | 11    |

Hoping for recovery in subsequent PRs (see comment: https://github.com/rust-lang/rust/pull/137796#issuecomment-2693307115).
